with text_Io, Ada.Integer_Text_Io, Grafos_Simples, Grafos_simples.Costes, Colas;
use text_Io, Ada.Integer_Text_Io, Grafos_Simples, Grafos_simples.Costes;

package algoritmos_Grafos is
	-- Procedimiento genrico para recorrer un grafo en profundidad
	-- aplicando a cada vrtice la operacin Tratar.
	generic
		with procedure Tratar(X: in Positive);
	procedure Profundidad(G: in Grafo'Class);

	-- El recorrido en amplitud se apoya en una cola
	-- para almacenar los vrtices a tratar.
	package Cola_Vrtices is new Colas(Positive);
	use Cola_Vrtices;

	-- Procedimiento genrico para recorrer un grafo en amplitud
	-- aplicando a cada vrtice la operacin Tratar.
	generic
		with procedure Tratar(X: in Positive);
	procedure Amplitud(G: in Grafo'Class);

	-- Estructura que representa un vrtice y un coste relacionado con l
	type Coste_Min is record
		Vrtice: Natural;
		Coste  : Natural;
	end record;

	-- Vector de costes
	type Costes_Mnimos is array(positive range <>) of Coste_Min;

	procedure Costes_Desde_fuente(G: in Grafo_Costes; Fuente: In Positive;
						Caminos: out Costes_Mnimos);

	-- Estructura que representa una arista y un coste relacionado con ella
	type Arista is record
		V1, V2: Positive;
		Coste : natural;
	end record;

	-- Vector de aristas con costes
	type Conjunto_aristas is array(Positive range <>) of Arista;

	procedure rbol_De_recubrimiento(G: in Grafo_Costes;
						Aristas: out Conjunto_Aristas);
end algoritmos_grafos;

