package Grafos_Simples is
	type Clase_Grafo is (ORIENTADO, nO_ORIENTADO);
	-- Tipo para especificar la clase del grafo.

	TYPE Grafo(Clase: Clase_Grafo; N: Positive) is tagged private;
	-- Representa grafos orientados o no orientados con N vrtices
	-- nmerados de 1 a N.

	procedure Conectar(G: in out Grafo; I, J: in Positive);
	-- Establece un arco o arista entre el vrtice I y el J.
	-- Si el grafo es orientado I es el extremo inicial del arco.

	procedure Desconectar(G: in out Grafo; I, J: in Positive);
	-- Elimina el arco o arista que haya entre el vrice I y el J.
	-- Si el grafo es orientado I es el extremo inicial del arco.
	-- Si el arco o arista a eliminar no existen no ocurre nada.

	function Conectados(G: in Grafo; I, J: in Positive) return Boolean;
	-- Devuelve verdadero si existe un arco o arista entre el vrtice
 	-- I y el J, y falso si no.
	-- Si el grafo es orientado I es el extremo inicial del arco.

	function Vrtices(G: in Grafo) return Positive;
	-- Devuelve el nmero de vrtices (N) del grafo.

private
	-- El grafo se va a representar mediante una
	-- matriz de adyacencia booleana.
	type Matriz_Adyacencia is
		array(Positive range <>,Positive range <>)
		of Boolean;

	-- El grafo se crea con N vrtices desconectados.
	type Grafo(Clase: Clase_Grafo; N: Positive) is tagged record												
		Adyacencia: Matriz_Adyacencia(1..N,1..N) :=
			(Others => (others => false));				
	end record;
		
end Grafos_simples;

